/************************************************************************************/
/*  Program name CAPPOEXT_RFQ_VENDOR.sql                                              */
/*  Creater:  Kenny, Leung (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 20 Jan 2006, Kenny Leung         First created                               */
/************************************************************************************/

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;
alter session set nls_date_format='YYYYMMDD HH24:MI:SS';

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPPOEXT_RFQ_VENDOR';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPPO_RFQ_VENDOR.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT PRV.* 
    FROM   PO_RFQ_VENDORS PRV,
           PO_HEADERS_ALL PH,
           HR_ORGANIZATION_UNITS HOU
    WHERE  PRV.PO_HEADER_ID = PH.PO_HEADER_ID   
    AND    PH.ORG_ID = HOU.ORGANIZATION_ID
    AND    HOU.NAME LIKE 'OU_' ||p_NGO||'%';


BEGIN
	lv_NGO_Name		:=	SUBSTR(UPPER('&1'), -4);

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
        
        lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
        
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			
			UTL_FILE.PUT_LINE(
                  lv_UTL_File,
				  C1.PO_HEADER_ID            ||CHR(9)||
                  C1.SEQUENCE_NUM            ||CHR(9)||
                  C1.LAST_UPDATE_DATE        ||CHR(9)||
                  C1.LAST_UPDATED_BY         ||CHR(9)||
                  C1.LAST_UPDATE_LOGIN       ||CHR(9)||
                  C1.CREATION_DATE           ||CHR(9)||
                  C1.CREATED_BY              ||CHR(9)||
                  C1.VENDOR_ID               ||CHR(9)||
                  C1.VENDOR_SITE_ID          ||CHR(9)||
                  C1.VENDOR_CONTACT_ID       ||CHR(9)||
                  C1.PRINT_FLAG              ||CHR(9)||
                  C1.PRINT_COUNT             ||CHR(9)||
                  C1.PRINTED_DATE            ||CHR(9)||
                  C1.ATTRIBUTE_CATEGORY      ||CHR(9)||
                  C1.ATTRIBUTE1              ||CHR(9)||
                  C1.ATTRIBUTE2              ||CHR(9)||
                  C1.ATTRIBUTE3              ||CHR(9)||
                  C1.ATTRIBUTE4              ||CHR(9)||
                  C1.ATTRIBUTE5              ||CHR(9)||
                  C1.ATTRIBUTE6              ||CHR(9)||
                  C1.ATTRIBUTE7              ||CHR(9)||
                  C1.ATTRIBUTE8              ||CHR(9)||
                  C1.ATTRIBUTE9              ||CHR(9)||
                  C1.ATTRIBUTE10             ||CHR(9)||
                  C1.ATTRIBUTE11             ||CHR(9)||
                  C1.ATTRIBUTE12             ||CHR(9)||
                  C1.ATTRIBUTE13             ||CHR(9)||
                  C1.ATTRIBUTE14             ||CHR(9)||
                  C1.ATTRIBUTE15             ||CHR(9)||
                  C1.REQUEST_ID              ||CHR(9)||
                  C1.PROGRAM_APPLICATION_ID  ||CHR(9)||
                  C1.PROGRAM_ID              ||CHR(9)||
                  C1.PROGRAM_UPDATE_DATE     
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No RFQ Vendors for NGO';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/

